<?php
/**
* Copyright (C) 2017 Petr Hucik <petr@getdatakick.com>
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@getdatakick.com so we can send you a copy immediately.
*
* @author    Petr Hucik <petr@getdatakick.com>
* @copyright 2018 Petr Hucik
* @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*/
namespace Revws;

class AppTranslation {
  private $module;

  public function __construct($module) {
    $this->module = $module;
  }

  public function getFrontTranslations() {
    return $this->changed(array(
      "Are you sure you want to delete this review?" => $this->l('Are you sure you want to delete this review?'),
      "Be the first to write a review!" => $this->l('Be the first to write a review!'),
      "Cancel" => $this->l('Cancel'),
      "Click here to reply" => $this->l('Click here to reply'),
      "Close" => $this->l('Close'),
      "Could you review these products?" => $this->l('Could you review these products?'),
      "Create review" => $this->l('Create review'),
      "Delete review" => $this->l('Delete review'),
      "Edit review" => $this->l('Edit review'),
      "Failed to create review" => $this->l('Failed to create review'),
      "Failed to delete review" => $this->l('Failed to delete review'),
      "Failed to load reviews" => $this->l('Failed to load reviews'),
      "Failed to update review" => $this->l('Failed to update review'),
      "Invalid number" => $this->l('Invalid number'),
      "No customer reviews for the moment." => $this->l('No customer reviews for the moment.'),
      "No" => $this->l('No'),
      "Please enter review details" => $this->l('Please enter review details'),
      "Please enter review title" => $this->l('Please enter review title'),
      "Please enter your email address" => $this->l('Please enter your email address'),
      "Please enter your name" => $this->l('Please enter your name'),
      "Please provide valid email address" => $this->l('Please provide valid email address'),
      "Please provide your name" => $this->l('Please provide your name'),
      "Please review %s" => $this->l('Please review %s'),
      "Reply from %s:" => $this->l('Reply from %s:'),
      "Report abuse" => $this->l('Report abuse'),
      "Review content must be set" => $this->l('Review content must be set'),
      "Review deleted" => $this->l('Review deleted'),
      "Review details" => $this->l('Review details'),
      "Review has been created" => $this->l('Review has been created'),
      "Review has been updated" => $this->l('Review has been updated'),
      "Review title must be set" => $this->l('Review title must be set'),
      "Review title" => $this->l('Review title'),
      "Save" => $this->l('Save'),
      "Sign in to write a review" => $this->l('Sign in to write a review'),
      "Thank you for reporting this review" => $this->l('Thank you for reporting this review'),
      "Thank you for your vote!" => $this->l('Thank you for your vote!'),
      "This review hasn't been approved yet" => $this->l('This review hasn\'t been approved yet'),
      "Update review" => $this->l('Update review'),
      "Was this comment useful to you?" => $this->l('Was this comment useful to you?'),
      "Write your answer" => $this->l('Write your answer'),
      "Write your review!" => $this->l('Write your review!'),
      "Yes" => $this->l('Yes'),
      "You haven't written any review yet" => $this->l('You haven\'t written any review yet'),
      "Your answer" => $this->l('Your answer'),
      "Your email address" => $this->l('Your email address'),
      "Your name" => $this->l('Your name'),
      "Your reviews" => $this->l('Your reviews'),
      "by" => $this->l('by')
    ));
  }

  public function getBackTranslations() {
    return $this->changed(array(
      "Actions" => $this->l('Actions'),
      "Admin notifications" => $this->l('Admin notifications'),
      "All languages" => $this->l('All languages'),
      "All reviews must be approved" => $this->l('All reviews must be approved'),
      "All reviews" => $this->l('All reviews'),
      "Allow reviews by annonymous visitors" => $this->l('Allow reviews by annonymous visitors'),
      "Allow reviews for products without review criteria" => $this->l('Allow reviews for products without review criteria'),
      "Allow reviews without details" => $this->l('Allow reviews without details'),
      "Applies to %s categories and %s products" => $this->l('Applies to %s categories and %s products'),
      "Applies to %s products" => $this->l('Applies to %s products'),
      "Applies to entire catalog" => $this->l('Applies to entire catalog'),
      "Applies to product from %s categories" => $this->l('Applies to product from %s categories'),
      "Applies to your entire catalog" => $this->l('Applies to your entire catalog'),
      "Approve" => $this->l('Approve'),
      "Are you sure you want to delete this criterion?" => $this->l('Are you sure you want to delete this criterion?'),
      "Are you sure?" => $this->l('Are you sure?'),
      "Author" => $this->l('Author'),
      "Cancel" => $this->l('Cancel'),
      "Categories" => $this->l('Categories'),
      "Choose rating style" => $this->l('Choose rating style'),
      "Click here to reply" => $this->l('Click here to reply'),
      "Close" => $this->l('Close'),
      "Create new review criterion" => $this->l('Create new review criterion'),
      "Create review" => $this->l('Create review'),
      "Criterion deleted" => $this->l('Criterion deleted'),
      "Criterion saved" => $this->l('Criterion saved'),
      "Custom" => $this->l('Custom'),
      "Customer account page" => $this->l('Customer account page'),
      "Customer notifications" => $this->l('Customer notifications'),
      "Customer" => $this->l('Customer'),
      "Data has been imported" => $this->l('Data has been imported'),
      "Date" => $this->l('Date'),
      "Default customer name format" => $this->l('Default customer name format'),
      "Delete criterion" => $this->l('Delete criterion'),
      "Delete review" => $this->l('Delete review'),
      "Delete" => $this->l('Delete'),
      "Disabled criterion" => $this->l('Disabled criterion'),
      "Display reviews in" => $this->l('Display reviews in'),
      "Does not apply to any product" => $this->l('Does not apply to any product'),
      "Edit criterion" => $this->l('Edit criterion'),
      "Edit review" => $this->l('Edit review'),
      "Edit" => $this->l('Edit'),
      "Email address for notifications" => $this->l('Email address for notifications'),
      "Email language" => $this->l('Email language'),
      "Emit microdata / rich snippets" => $this->l('Emit microdata / rich snippets'),
      "Failed to approve review" => $this->l('Failed to approve review'),
      "Failed to delete criterion" => $this->l('Failed to delete criterion'),
      "Failed to delete review" => $this->l('Failed to delete review'),
      "Failed to load data" => $this->l('Failed to load data'),
      "Failed to migrate data" => $this->l('Failed to migrate data'),
      "Failed to save criterion" => $this->l('Failed to save criterion'),
      "Failed to save review" => $this->l('Failed to save review'),
      "Failed to undelete review" => $this->l('Failed to undelete review'),
      "Failed to update settings" => $this->l('Failed to update settings'),
      "Filter list" => $this->l('Filter list'),
      "Guest visitor" => $this->l('Guest visitor'),
      "Hide review section when is empty" => $this->l('Hide review section when is empty'),
      "Icon css class" => $this->l('Icon css class'),
      "Import review data and criteria settings from other modules" => $this->l('Import review data and criteria settings from other modules'),
      "Invalid number" => $this->l('Invalid number'),
      "Label" => $this->l('Label'),
      "Loading..." => $this->l('Loading...'),
      "Max review requests" => $this->l('Max review requests'),
      "Migrate data" => $this->l('Migrate data'),
      "Migrate reviews and criteria from product comments module" => $this->l('Migrate reviews and criteria from product comments module'),
      "Moderation" => $this->l('Moderation'),
      "No reviews" => $this->l('No reviews'),
      "No" => $this->l('No'),
      "Nothing found" => $this->l('Nothing found'),
      "Nothing to approve" => $this->l('Nothing to approve'),
      "Notify customer when" => $this->l('Notify customer when'),
      "Order reviews by" => $this->l('Order reviews by'),
      "Please enter customer name" => $this->l('Please enter customer name'),
      "Please enter review details" => $this->l('Please enter review details'),
      "Please enter review title" => $this->l('Please enter review title'),
      "Please enter reviewer email" => $this->l('Please enter reviewer email'),
      "Please provide valid email address" => $this->l('Please provide valid email address'),
      "Please provide your name" => $this->l('Please provide your name'),
      "Preview" => $this->l('Preview'),
      "Product comparison page" => $this->l('Product comparison page'),
      "Product comparison" => $this->l('Product comparison'),
      "Product detail page" => $this->l('Product detail page'),
      "Product listing page" => $this->l('Product listing page'),
      "Product" => $this->l('Product'),
      "Products" => $this->l('Products'),
      "Rating shape size" => $this->l('Rating shape size'),
      "Ratings" => $this->l('Ratings'),
      "Reply from %s:" => $this->l('Reply from %s:'),
      "Report abuse" => $this->l('Report abuse'),
      "Review content must be set" => $this->l('Review content must be set'),
      "Review content" => $this->l('Review content'),
      "Review criteria" => $this->l('Review criteria'),
      "Review details" => $this->l('Review details'),
      "Review has been activated" => $this->l('Review has been activated'),
      "Review has been approved" => $this->l('Review has been approved'),
      "Review has been created" => $this->l('Review has been created'),
      "Review has been marked as deleted" => $this->l('Review has been marked as deleted'),
      "Review moderation" => $this->l('Review moderation'),
      "Review saved" => $this->l('Review saved'),
      "Review title must be set" => $this->l('Review title must be set'),
      "Review title" => $this->l('Review title'),
      "Reviewer email" => $this->l('Reviewer email'),
      "Reviewer name" => $this->l('Reviewer name'),
      "Reviews per page" => $this->l('Reviews per page'),
      "Reviews" => $this->l('Reviews'),
      "Save changes" => $this->l('Save changes'),
      "Save" => $this->l('Save'),
      "Search customers" => $this->l('Search customers'),
      "Search products" => $this->l('Search products'),
      "Search" => $this->l('Search'),
      "Select customer" => $this->l('Select customer'),
      "Select product" => $this->l('Select product'),
      "Send email when" => $this->l('Send email when'),
      "Send thank you email" => $this->l('Send thank you email'),
      "Separate block" => $this->l('Separate block'),
      "Settings successfully saved" => $this->l('Settings successfully saved'),
      "Settings" => $this->l('Settings'),
      "Show average ratings on product comparison page" => $this->l('Show average ratings on product comparison page'),
      "Show average ratings on product listing page" => $this->l('Show average ratings on product listing page'),
      "Show average ratings on product page" => $this->l('Show average ratings on product page'),
      "Show review section in customer account" => $this->l('Show review section in customer account'),
      "Show sign in button for annonymous visitors" => $this->l('Show sign in button for annonymous visitors'),
      "Sort" => $this->l('Sort'),
      "Structured Data / Rich Snippets" => $this->l('Structured Data / Rich Snippets'),
      "Tab" => $this->l('Tab'),
      "Theme and Appearance" => $this->l('Theme and Appearance'),
      "This action will delete all your curent reviews and criteria settings!" => $this->l('This action will delete all your curent reviews and criteria settings!'),
      "This review hasn't been approved yet" => $this->l('This review hasn\'t been approved yet'),
      "Unapproved reviews" => $this->l('Unapproved reviews'),
      "Undelete" => $this->l('Undelete'),
      "Visitors can delete their reviews" => $this->l('Visitors can delete their reviews'),
      "Visitors can edit their reviews" => $this->l('Visitors can edit their reviews'),
      "Visitors can mark reviews as useful" => $this->l('Visitors can mark reviews as useful'),
      "Visitors can report abusive, fake, or incorrect reviews" => $this->l('Visitors can report abusive, fake, or incorrect reviews'),
      "Votes" => $this->l('Votes'),
      "Was this comment useful to you?" => $this->l('Was this comment useful to you?'),
      "What to approve" => $this->l('What to approve'),
      "Write your answer" => $this->l('Write your answer'),
      "Yes" => $this->l('Yes'),
      "Your answer" => $this->l('Your answer'),
      "edits of already approved review must be validated" => $this->l('edits of already approved review must be validated'),
      "employee approves review" => $this->l('employee approves review'),
      "employee deletes review" => $this->l('employee deletes review'),
      "employee rejects review" => $this->l('employee rejects review'),
      "employee replies to review" => $this->l('employee replies to review'),
      "new reviews must be approved" => $this->l('new reviews must be approved'),
      "please create javascript function named 'revwsFormatName' and include it to product page. For example" => $this->l('please create javascript function named \'revwsFormatName\' and include it to product page. For example'),
      "review author deletes review" => $this->l('review author deletes review'),
      "review author updates review" => $this->l('review author updates review'),
      "review needs approval" => $this->l('review needs approval'),
      "reviews reported as abusive must be re-approved" => $this->l('reviews reported as abusive must be re-approved'),
      "visitor creates new review" => $this->l('visitor creates new review')
    ));
  }

  private function l($str) {
    return html_entity_decode($this->module->l($str, 'app-translation'));
  }

  private function changed($array) {
    $ret = array();
    foreach ($array as $key => $value) {
      if ($value != $key) {
        $ret[$key] = $value;
      }
    }
    return $ret;
  }
}
